#!/usr/bin/php
<?php
// load the config, create the connection and load the repo sepcified on the cmd line args
// we will then have $client and $repo available
require('setup.php');

use RRule\RRule;

//callback function to add/replace the tag with our text
function updateIssueBody($issue,$text){
  // add a tag to the body if to doesn't exist
  if( strpos($issue->body,'<!--BOT-->')===false ){
    $issue->body.="\n<!--BOT--><hr/><!--ENDBOT-->";
  }
  //replace the tag contents with the result from our $text function
  $issue->body=preg_replace("#<!--BOT-->.*?<!--ENDBOT-->#s",'<!--BOT--><hr/>'.$text.'<!--ENDBOT-->',$issue->body);
  $issue->save();
};

//loop through each issue that has a RRULE
foreach($repo->getIssues(['q'=>'RRULE:']) as $issue){
  //extract the rule text
	if(preg_match('/RRULE:\s?(.*)/',$issue->body,$matches)){
		$rruletxt=$matches[1];
    //create the rule, report any exceptions
		try{
			$rrule = new RRule($rruletxt);
		}catch(Exception $e){
			$result="\n```plain\n".$e->getMessage()." ($rruletxt)\n```\n";
			updateIssueBody($issue,$result);
			continue;
		}
  }else{ //couldn't extract, report error
    updateIssueBody($issue,"Can't extract RRULE:");
    continue;
  }

  // if we get here, then there is a valid rrule :)

  // calcultate some useful info
  $next_inc=$rrule->getOccurrencesAfter(date('Y-m-d'),$inclusive=true,$limit=1)[0];
  $next_exc=$rrule->getOccurrencesAfter(date('Y-m-d'),$inclusive=false,$limit=1)[0];
  $today=$next_inc->format('Y-m-d')==date('Y-m-d');

  //some debug
  $result=$rrule->humanReadable().
    "<br/>\n NOW: ".date('Y-m-d').
    "<br/>\n First: ".$rrule[0]->format('Y-m-d').
    "<br/>\n Second: ".$rrule[1]->format('Y-m-d').
    "<br/>\n Today: ".($today?'Yes':'no').
    "<br/>\n Next Inc: ".$next_inc->format('Y-m-d').
    "<br/>\n Next Exc: ".$next_exc->format('Y-m-d');
  updateIssueBody($issue,$result);

  //is it today?
  if($today){
    $issue->addComment("Today (NEXT:".$next_exc->format('Y-m-d').")");
  }

  // not working https://github.com/go-gitea/gitea/issues/8179
	//$issue->due_date=$rrule[0]->format('c');
	//$issue->save();
}
